package de.steamwar.lobby.particle.elements;

import de.steamwar.lobby.particle.ParticleElement;
import de.steamwar.lobby.particle.ParticleTickData;
import org.bukkit.Location;
import org.bukkit.util.Vector;

public class Circle extends DelegatingParticleElement {

    private double distance;
    private double speed;

    public Circle(ParticleElement particleElement) {
        super(particleElement);
        this.distance = 1;
        this.speed = 1;
    }

    public Circle(ParticleElement particleElement, double distance, double speed) {
        super(particleElement);
        this.distance = distance;
        this.speed = speed;
    }

    @Override
    public String attribute() {
        return "PARTICLE_ATTRIBUTE_CIRCLE";
    }

    @Override
    public void tick(ParticleTickData particleTickData) {
        Location location = particleTickData.getLocation();

        Vector vector = new Vector(distance, 0, 0);
        vector.rotateAroundY((particleTickData.getDeg() * speed) % 360);
        ParticleTickData nParticleTickData = particleTickData.withLocation(location.clone().add(vector));
        particleElement.tick(nParticleTickData);
    }
}
